#! --PERL--
##
## SMIME Filter, read a message write it signed using s/mime

## Load the modules and whatever we need.

print STDERR 'xxx appel de smime_sfilter';
use strict;

use lib '--DIR--/bin';
use Getopt::Std;

use Mail::Address;
use Mail::Internet;
use MIME::Parser;
use MIME::Entity;
use MIME::Words;
use File::Path;

my $openssl_path = '/usr/local/ssl/bin/openssl';
my $temp = '/home/sympa/spool/crypt';

##            k		-> signer key path
##            c         -> signer certificat path

Getopt::Std::getopts('ds:k:c:');

## Load configuration file
unless (-r $Getopt::Std::opt_k) {
    print STDERR 'unable to open private key file : %s',$Getopt::Std::opt_k;
   exit(1);
}
unless (-r $Getopt::Std::opt_c) {
    print STDERR 'unable to open private key file : %s',$Getopt::Std::opt_k;
   exit(1);
}

my $key = $Getopt::Std::opt_k ;
my $cert = $Getopt::Std::opt_c ;
my $debug = $Getopt::Std::opt_d ;

my $parser = new MIME::Parser;
$parser->output_to_core(1);

my $msg; 

my  $temporary_file = "$temp/signed.$$";
my  $temporary_file_in = "$temp/incomming.$$";

open STDIN ;
open INCOMMING, ">$temporary_file_in" ;

while (<STDIN>) {
    print INCOMMING ;
}
close STDIN ;
close INCOMMING ;

open INCOMMING, "$temporary_file_in" ;
unless ($msg = $parser->read(\*INCOMMING)) {
    print STDERR 'Unable to parse incomming message';
    return undef;
}
close INCOMMING;

my  $temporary_file = "$temp/signed.$$";

if (!open(INMSG, "| $openssl_path smime -sign -signer $cert -passin pass:amindada -inkey $key -in $temporary_file_in -out $temporary_file")) {
    print STDERR 'Can\'t sign message';
}
$msg->print(\*INMSG);
close(INMSG);


open (NEWMSG, $temporary_file);
my $nparser = new MIME::Parser;
$nparser->output_to_core(1);

my $cryptedmsg;
unless ($cryptedmsg = $nparser->read(\*NEWMSG)) {
    print STDERR 'Unable to parse signed message';
    return undef;
}
close NEWMSG ;
unlink ($temporary_file) unless ($debug);

#$cryptedmsg->print(\*STDOUT);
#exit;

## foreach header defined in  the incomming message but undefined in the
## crypted message, add this header in the crypted form.
my $predefined_headers ;
foreach my $header ($cryptedmsg->head->tags) {
    $predefined_headers->{$header} = 1 if ($cryptedmsg->head->get($header)) ;
}
foreach my $header ($msg->head->tags) {
    $cryptedmsg->head->add($header,$msg->head->get($header)) unless $predefined_headers->{$header} ;
}
$cryptedmsg->print(\*STDOUT);

    
1;






